@echo off

setlocal

set INPUT=

if "%1" == "/?" goto help:

set FIRST=TRUE

if "%1" == "/+" (set CALC_MODE=ADD & shift & goto next:)

set CALC_MODE=SEPARATE



rem Now decide, if expressions are provided as parameters or if they

rem have to be read from the stdinput:

:next

if "%1" == "" goto standardinput:



:param_loop

if "%1" == "" goto append_quit:

if %CALC_MODE%==ADD goto add_mode:

if %FIRST%==FALSE goto not_first:

set INPUT=print %1 

set FIRST=FALSE

goto param_loop_next:

:not_first

set INPUT=%INPUT% ; print %1

goto param_loop_next:

:add_mode

if %FIRST%==TRUE goto was_first:

set INPUT=%INPUT% + %1

goto param_loop_next:

:was_first                   

set INPUT=print %1           

set FIRST=FALSE              

:param_loop_next             

shift                            

goto param_loop:                 



:append_quit                          

set INPUT=%INPUT% ; quit              

goto doit:                             



:standardinput                         

if %CALC_MODE%==SEPARATE goto stdin_sep:

(sed -e "s/\([^ ]\)  */\1 + /g" -e "2,$ s/^/+ /" -e "1 s/\([^ ]*\)/print \1/" -e "s/$/\\/" & echo ;quit) | gnuplot 2>&1 | sed -e "s/^.\(.*\)$/\1/"

goto ende:                             

:stdin_sep                             

(sed -e "s/\([^ ]\)  */\1; print /g" -e "s/^/print /" & echo quit) | gnuplot 2>&1 | sed -e "s/^.\(.*\)$/\1/"

goto ende:                            



:doit

rem remove leading tab from output

echo %INPUT% | gnuplot 2>&1 | sed -e "s/^.\(.*\)$/\1/"

goto ende:



:help

echo Usage: calc [/?] [/+] [^<expression1^> [^<exxpression2^> ...]]

echo    '/?' : Outputs this help message

echo    '/+' : The results of all expressions are added and only one

echo           value makes up the result.

echo    If no expressions are provided, expressions are read from stdin.



:ende

endlocal

